HDU 1027 Ignatius and the Princess II (水题,排列)

来源:互联网 发布:loadrunner java 录制 编辑:程序博客网 时间:2024/06/16 21:46

Ignatius and the Princess II

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 8034    Accepted Submission(s): 4727


Problem Description
Now our hero finds the door to the BEelzebub feng5166. He opens the door and finds feng5166 is about to kill our pretty Princess. But now the BEelzebub has to beat our hero first. feng5166 says, "I have three question for you, if you can work them out, I will release the Princess, or you will be my dinner, too." Ignatius says confidently, "OK, at last, I will save the Princess."

"Now I will show you the first problem." feng5166 says, "Given a sequence of number 1 to N, we define that 1,2,3...N-1,N is the smallest sequence among all the sequence which can be composed with number 1 to N(each number can be and should be use only once in this problem). So it's easy to see the second smallest sequence is 1,2,3...N,N-1. Now I will give you two numbers, N and M. You should tell me the Mth smallest sequence which is composed with number 1 to N. It's easy, isn't is? Hahahahaha......"
Can you help Ignatius to solve this problem?
 

Input
The input contains several test cases. Each test case consists of two numbers, N and M(1<=N<=1000, 1<=M<=10000). You may assume that there is always a sequence satisfied the BEelzebub's demand. The input is terminated by the end of file.
 

Output
For each test case, you only have to output the sequence satisfied the BEelzebub's demand. When output a sequence, you should print a space between two numbers, but do not output any spaces after the last number.
 

Sample Input
6 411 8
 

Sample Output
1 2 3 5 6 41 2 3 4 5 6 7 9 8 11 10
 
思路:直接调用stl里的全排列更简单,一开始想着会是搜索题,看了题目发现是一个水题,于是就写了一个深搜试着能不能过,最后不幸超时,于是改写成两段深搜,。。。
理解了题目以后可以发现要找第m小,那么对给定数n的最后temp(temp!>=m)位进行排序找到第m个序列输出就好,因为8!>10000,所以最多也是对后8位进行全排列,一定不会超时。。
输出分两个部分:
1.bfs()直接输出1—(n-temp)
2.bfs2()输出从(n-temp+1)—n的第m个全排列就好
题目简单,自己想想就过了,代码有点乱
代码:
#include<stdio.h>#include<string.h>#include<string>using namespace std;int ans[1010];int vis[1010];int temp;int n,m;int count;bool flag;void dfs(int len){if(flag) return ;if(len==(n-temp)) {for(int i=0;i<n-temp;i++){printf("%d ",ans[i]); }//printf("\n");flag=true;}for(int i=1;i<=n;i++){if(vis[i]) continue;ans[len]=i;vis[i]=true;dfs(len+1);vis[i]=false;}}void dfs2(int st,int len){//printf("%d ",ans[len]);if(flag) return ;if(len==temp){    count++;//return ;} if(count==m){for(int i=0;i<temp;i++){printf("%d",ans[i]); if(i<temp-1) printf(" ");}printf("\n");flag=true;return ;}for(int i=st;i<=n;i++){if(vis[i]) continue;ans[len]=i;vis[i]=true;dfs2(st,len+1);vis[i]=false;}}int main(){    while(~scanf("%d%d",&n,&m))    {    memset(vis,false,sizeof(vis));    long long sum=1;        for(int i=1;i<=8;i++)    {    sum*=i;     if(sum>=m){temp=i;break; }  }    count=0;    flag=false;    dfs(0);        flag=false;    dfs2(n-temp+1,0);}} 



0 0
原创粉丝点击